```
/party/bar
```

or simply a **bar** is an OSC controlled demoparty ~drink~ audio/video
mixing service.

Started from scratch as a simple idea that you can run demoparty 
from the CLI, as a network service or by pushing MIDI buttons and tuning
knobs.

Central point of the service is...

Screenbar
---------

Screenbar is a simple screen overlay for demoscene party system.
Long bar on top of the screen draws directly from Amiga OS Screenbars.

    /party/bar/title/set      - sets title bar (string)    
    /party/bar/t/reset        - reset timer         

Media player
------------

OSC controlled MPV

    /party/media/play         - play media file, set path by string message
    /party/media/stop         - stop (pause) playing media
    /party/media/volume       - set volume for the media

Emulators
---------

Emulators be run locally on the party machine and have similar interface with
the default media player. They are there for convinience. You should not need
them during the party.

Real machines
-------------

Look into `main.go` for machine APIs.

C64
---

Remote controlled via 
[REST API](https://1541u-documentation.readthedocs.io/en/latest/api/api_calls.html)
of [1541 Ultimate-II (+)](https://1541u-documentation.readthedocs.io/en/latest/)
FPGA based floppy disk emulator
with [firmware](https://ultimate64.com/Firmware) version 3.11 or higher.
Device provides access to DMA on your C64 and it can be pretty powerful.
Keypresses can be sent via Keyboardcache (e.g. send `F1` using `POKE 631,135; POKE 198,1`)
More info on [C64 Wiki's Keyboard page](https://www.c64-wiki.com/wiki/Keyboard#direct_addressing_of_a_key)

Amiga
-----

Amigas can be reset remotely using reset line of Gayle chip in
[A600](https://www.amigawiki.org/dnl/schematics/A600_R2.pdf),
[A1200](https://www.amigawiki.org/dnl/schematics/A1200_R1.pdf)
[etc](https://www.amigawiki.org/doku.php?id=en:service:schematics).
[FlashFloppy](https://github.com/keirf/flashfloppy) equipped floppy emulators (aka GOTEKs)
can be mounted as remote, networked pendrives.
